import "Turbine.UI";
import "Turbine.UI.Lotro";
import "Turbine";
import "Turbine.Gameplay";
import "Turbine.Animation";
import "Deusdictum.UI.DragBar";

function loadSettings()
cjhSettings=Turbine.PluginData.Load(Turbine.DataScope.Character, "CJHelper");
if (type(cjhSettings) ~= "table") then
		cjhSettings = {bXset=800,bYset=20,cjhChat= false};
	end
	if (cjhSettings.bXset == nil)then
		cjhSettings.bXset=800;
	end
	if (cjhSettings.bYset == nil)then
		cjhSettings.bYset=20;
	end
	if (cjhSettings.cjhChat == nil)then
		cjhSettings.cjhChat= false;
	end
	return cjhSettings;
end

function print(text) Turbine.Shell.WriteLine("<rgb=#3399FF>CJHelper:</rgb> "..text) end

function saveSettings(bXcoord,bYcoord,cjhChatSet)
	cjhSettings.bXset=bXcoord;
	cjhSettings.bYset=bYcoord;
	cjhSettings.cjhChat=cjhChatSet;
	Turbine.PluginData.Save(Turbine.DataScope.Character, "CJHelper", cjhSettings);
end

cjhPlayer = Turbine.Gameplay.LocalPlayer.GetInstance();
cjh_Command = Turbine.ShellCommand();

cjhSettings = loadSettings();
local bXset = cjhSettings.bXset;
local bYset = cjhSettings.bYset;
local cjhChat = cjhSettings.cjhChat;
local cjhColourText = "Blue (Left) - ";

cjhNumText = 1;
cjCol = 1;
cjColour = Turbine.UI.Color(1,0,0,1);
cjWhite = Turbine.UI.Color(1,1,1);
cjBlack = Turbine.UI.Color(0,0,0);
cjHide = 1.0;
setMV = true;
cjhChatOn = cjhChat;

cjButton = Turbine.UI.Window();
--cjButton:SetParent("Fellowship Manoeuvre Display");
cjButton:SetOpacity(cjHide);
cjButton:SetMouseVisible (true);
cjButton:SetBackColor(cjWhite);
cjButton:SetBlendMode(0);
cjButton:SetVisible(setMV);
cjButton:SetWantsUpdates(true);
cjButton:SetPosition(bXset,bYset);
cjButton:SetSize(32,32);
cjButton.DragBar = Deusdictum.UI.DragBar(cjButton,"CJ Helper");

cjText = Turbine.UI.Label();
cjText:SetParent(cjButton);
cjText:SetSize(28,28);
cjText:SetBackColor(cjColour);
cjText:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
cjText:SetPosition(2,2);
cjText:SetFont(Turbine.UI.Lotro.Font.Verdana22);
cjText:SetText(cjhNumText);
cjText:SetMouseVisible(setMV);
cjText:SetForeColor(cjWhite);

cjhDot = Turbine.UI.Label();
cjhDot:SetParent(cjButton);
cjhDot:SetSize(8,3);
cjhDot:SetBackColor(cjWhite);
cjhDot:SetPosition(0,15);
cjhDot:SetMouseVisible(false);

function cjText:MouseClick(args)
	if (args.Button == Turbine.UI.MouseButton.Left) then
		if (not self.dragging) then
			if (cjhNumText < 6) then
				cjhNumText = (cjhNumText + 1);
			else
				cjhNumText = 1;
			end
			cjText:SetText(cjhNumText);
			bX, bY = cjButton:GetPosition();
			saveSettings( bX, bY, cjhChatOn );
		end
	end
	
	if (args.Button == Turbine.UI.MouseButton.Right) then
			if (cjCol < 4) then
				cjCol = (cjCol + 1);
			else
				cjCol = 1;
			end
			if (cjCol < 2) then
				cjText:SetForeColor(cjWhite);
				cjButton:SetBackColor(cjWhite);
				cjhDot:SetBackColor(cjWhite);
			else
				cjText:SetForeColor(cjBlack);
				cjButton:SetBackColor(cjBlack);
				cjhDot:SetBackColor(cjBlack);
			end
			if (cjCol == 1) then
				cjColour = Turbine.UI.Color(1,0,0,1); --blue (blau, bleue), left (linke, gauche)
				cjhColourText = "Blue (Left) - ";
				cjhDot:SetPosition(0,15);
				cjhDot:SetSize(8,3);
			end
			if (cjCol == 2 ) then
				cjColour = Turbine.UI.Color(1,0.6,0,0); --red (rot, rouges), up (auf, le haut)
				cjhColourText = "Red (Up) - ";
				cjhDot:SetPosition(14,0);
				cjhDot:SetSize(4,8);
			end
			if (cjCol == 3 ) then
				cjColour = Turbine.UI.Color(1,0,0.7,0); --green (grun, verte), right  (recht, droit)
				cjhColourText = "Green (Right) - ";
				cjhDot:SetPosition(24,14);
				cjhDot:SetSize(8,4);
			end
			if (cjCol == 4 ) then
				cjColour = Turbine.UI.Color(1,0.7,0.7,0); --yellow (gelb, jaunes), down (daunen, bas)
				cjhColourText = "Yellow (Down) - ";
				cjhDot:SetPosition(15,25);
				cjhDot:SetSize(4,7);
			end
			cjText:SetBackColor(cjColour);
	end
	if (cjhChatOn == true) then
		print(cjhColourText .. cjhNumText);
	end
end

function cjhPlayer:InCombatChanged(sender, args)
	if (cjhPlayer:IsInCombat()) then
		cjHide = 1.0;
		setMV = false;
		else
		cjHide = 0.0;
		setMV = true;
	end
	cjButton:SetOpacity(cjHide);
	cjButton:SetMouseVisible(setMV);
	cjText:SetMouseVisible(setMV);
end

function cjh_Command:Execute( cmd )
	if cmd=="cjhchat" then
		if cjhChatOn == true then
			cjhChatOn = false;
			print("Chat text is now off.");
		else
			cjhChatOn = true;
			print("Chat text is now on.");
		end
		cjhChat = cjhChatOn;
		bX, bY = cjButton:GetPosition();
		saveSettings( bX, bY, cjhChatOn );
	end
end

cjButton.MouseEnter = function(sender, args)
	cjHide = 1.0;
	cjButton:SetOpacity(cjHide);
end

cjButton.MouseLeave = function(sender, args)
	if (not cjhPlayer:IsInCombat()) then
		cjHide = 0.0;
	end
	cjButton:SetOpacity(cjHide);
end

Turbine.Shell.AddCommand( "cjhchat",cjh_Command );

print("v1.0 by Templedog - enjoy ;-)");
print("Use /cjhchat to toggle text output.");